apps/accounts/urls.py
from django.urls import path

from . import views

app_name = "accounts"

urlpatterns = [
    path("login/", views.LoginView.as_view(), name="login"),
    path("logout/", views.logout, name="logout"),
    path("search/", views.user_search, name="user_search"),
    path("update/", views.user_update, name="user_update"),
    path("user/<int:pk>/", views.UserDetailView.as_view(), name="user_details"),
    path("questionnaires/", views.ProfileView.as_view(), name="account_questionnaires"),
    path(
        "questionnaires/status/<int:user_id>/",
        views.PublicQuestionnaireListView.as_view(),
        name="questionnaires_public_list",
    ),
    path(
        "questionnaires/status/",
        views.QuestionnaireStatusListView.as_view(),
        name="questionnaires_status_list",
    ),
    path(
        "questionnaires/search/",
        views.QuestionnaireSearchView.as_view(),
        name="staff_questionnaires_search",
    ),
]

apps/questionnaire/urls.py
from django.urls import include, path

from . import views

urlpatterns = [
    path("upload/", views.generic_file_upload, name="file_upload"),
    path("file/<action>/<uid>/", views.generic_file_serve, name="file_serve"),
    path(
        "edit/<identifier>/lock/",
        views.QuestionnaireLockView.as_view(),
        name="lock_questionnaire",
    ),
    path("geo/", views.get_places, name="slm_places"),
    path("update/", views.get_places, name="update_slm_places"),
    path("", include("apps.sample.urls")),
]

apps/wocat/urls.py
from django.urls import path
from django.views.generic import TemplateView

from apps.questionnaire.views import QuestionnaireListView, QuestionnaireFilterView

app_name = "wocat"

urlpatterns = [
    path("", TemplateView.as_view(template_name="wocat/home.html"), name="home"),
    path(
        "help/questionnaire/",
        TemplateView.as_view(
            template_name="wocat/help/questionnaire_introduction.html"
        ),
        name="help_questionnaire_introduction",
    ),
    path("faq/", TemplateView.as_view(template_name="wocat/faq.html"), name="faq"),
    path("add/", TemplateView.as_view(template_name="wocat/add.html"), name="add"),
    path(
        "list/",
        QuestionnaireListView.as_view(configuration_code=__package__),
        name="questionnaire_list",
    ),
    path(
        "list_partial/",
        QuestionnaireListView.as_view(configuration_code=__package__),
        name="questionnaire_list_partial",
    ),
    path(
        "filter/",
        QuestionnaireFilterView.as_view(configuration_code=__package__),
        name="questionnaire_filter",
    ),
    path(
        "filter_partial/",
        QuestionnaireFilterView.as_view(configuration_code=__package__),
        name="questionnaire_filter_partial",
    ),
    # path("", include(("apps.accounts.urls", "accounts"), namespace="accounts")),
    # path("", include(("apps.approaches.urls", "approaches"), namespace="approaches")),
    # path("", include(("apps.sample.urls", "sample"), namespace="sample")),
    # path("", include(("apps.api.urls.v1", "v1"), namespace="v1")),
    # path(
    #     "", include(("apps.samplemulti.urls", "samplemulti"), namespace="samplemulti")
    # ),
    # path(
    #     "",
    #     include(("apps.samplemodule.urls", "samplemodule"), namespace="samplemodule"),
    # ),
]

config/urls.py
from django.conf import settings
from django.conf.urls.i18n import i18n_patterns
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import reverse_lazy, path, include
from django.views.generic import TemplateView, RedirectView

from apps.qcat.views import AdminLoginView, FactsTeaserView

urlpatterns = [
    path("about/", include("apps.qcat.urls")),
    path("grappelli/", include("grappelli.urls")),
    path("admin/login/", AdminLoginView.as_view(), name="admin_login"),
    path("admin/", admin.site.urls),
    # path("sitemap.xml", sitemap, {"sitemaps": views.static_sitemap}, name="django.contrib.sitemaps.views.sitemap",),
    path("robots.txt", TemplateView.as_view(template_name="robots.txt")),
    path("api/temp1/", include("apps.api.urls.temp")),
]
# en/questionnaire
urlpatterns += i18n_patterns(
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("wocat:home"), permanent=False),
        name="home",
    ),
    path("accounts/", include("apps.accounts.urls")),
    path("api/", include("apps.api.urls")),
    path("configuration/", include("apps.configuration.urls")),
    path("notifications/", include("apps.notifications.urls")),
    path("qcat/facts_teaser", FactsTeaserView.as_view(), name="facts_teaser"),
    path("questionnaire/", include("apps.questionnaire.urls")),
    path("search/", include("apps.search.urls")),
    path("samplemulti/", include("apps.samplemulti.urls")),
    path("summary/", include("apps.summary.urls")),
    path("unccd/", include("apps.unccd.urls")),
    path("wocat/", include("apps.wocat.urls")),
    path("wocat/approaches/", include("apps.approaches.urls")),
    path("wocat/cca/", include("apps.cca.urls")),
    path("wocat/cbp/", include("apps.cbp.urls")),
    path("wocat/technologies/", include("apps.technologies.urls")),
    path("wocat/watershed/", include("apps.watershed.urls")),
)

if settings.DEBUG:
    urlpatterns += [path("__debug__/", include("debug_toolbar.urls"))]

urlpatterns += i18n_patterns(
    path("samplemodule/", include("apps.samplemodule.urls")),
    path("404/", TemplateView.as_view(template_name="404.html")),
    path("500/", TemplateView.as_view(template_name="500.html")),
    path("503/", TemplateView.as_view(template_name="503.html")),
) + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

apps/accounts/forms.py
import floppyforms
from django.contrib.auth.forms import AuthenticationForm
from django.utils.translation import gettext_lazy as _


class WocatAuthenticationForm(floppyforms.Form, AuthenticationForm):
    username = floppyforms.CharField(
        max_length=255,
        label=_("E-mail address"),
        widget=floppyforms.TextInput(attrs={"tabindex": 1, "autofocus": True}),
    )
    password = floppyforms.CharField(
        label=_("Password"), widget=floppyforms.PasswordInput(attrs={"tabindex": 2})
    )

apps/accounts/views.py
import functools
import logging
import operator

from django.contrib import messages
from django.contrib.auth import logout as django_logout, login as django_login
from django.contrib.auth.decorators import login_required
from django.contrib.auth.mixins import LoginRequiredMixin
from django.db import IntegrityError
from django.db.models import Q
from django.http import Http404
from django.http import HttpResponseRedirect, JsonResponse
from django.shortcuts import get_object_or_404, redirect, resolve_url
from django.urls import reverse
from django.utils.decorators import method_decorator
from django.utils.http import url_has_allowed_host_and_scheme
from django.utils.translation import gettext as _
from django.views.decorators.cache import never_cache
from django.views.decorators.debug import sensitive_post_parameters
from django.views.decorators.http import require_POST
from django.views.generic import DetailView, FormView
from django.views.generic import ListView

from apps.configuration.configuration import QuestionnaireConfiguration
from apps.questionnaire.models import Questionnaire, STATUSES
from apps.questionnaire.utils import query_questionnaires, get_list_values
from apps.questionnaire.view_utils import get_paginator, get_pagination_parameters
from .client import remote_user_client
from .conf import settings
from .forms import WocatAuthenticationForm
from .models import User

logger = logging.getLogger(__name__)


class LoginView(FormView):
    """
    This view handles the login form and authenticates users.
    """

    form_class = WocatAuthenticationForm
    template_name = "login.html"
    success_url = settings.ACCOUNTS_LOGIN_SUCCESS_URL

    @method_decorator(never_cache)
    @method_decorator(sensitive_post_parameters("password"))
    def dispatch(self, *args, **kwargs):
        if hasattr(self.request, "user") and self.request.user.is_authenticated:
            return redirect(self.get_success_url())

        res = super().dispatch(*args, **kwargs)
        return res

    def get_context_data(self, **kwargs):
        # Add next_url to context to show notification in login form.
        context = super().get_context_data(**kwargs)
        context.update(
            {
                "next_url": self.request.GET.get("next"),
            }
        )
        return context

    def form_valid(self, form):
        # Put the user on the request, and add a welcome message.
        user = form.get_user()
        django_login(self.request, user)
        messages.info(self.request, _("Welcome {}").format(user.firstname))
        return HttpResponseRedirect(self.get_success_url())

    def form_invalid(self, form):
        """
        If this user has logged in before, check if the account was deactivated
        when relaunching the wocat website. If so, return a redirect to the
        reactivation view on the new wocat website.
        """
        has_user = User.objects.filter(email=form.cleaned_data.get("username"))
        if has_user.exists() and has_user.count() == 1:
            user_info = remote_user_client.get_user_information(has_user[0].pk)
            if user_info and not user_info.get("is_active", True):
                return HttpResponseRedirect(settings.REACTIVATE_WOCAT_ACCOUNT_URL)

        remote_addr = getattr(self.request, "META", {}).get("REMOTE_ADDR")
        if remote_addr:
            logger.warning("Invalid login attempt: %s" % remote_addr)
        return super().form_invalid(form)

    def get_success_url(self):
        # Explicitly passed ?next= url takes precedence.
        redirect_to = self.request.GET.get("next") or reverse(self.success_url)
        # Redirect UNCCD focal points to the list filtered with Questionnaires
        # from their country. Only if no "next" is set.
        if self.request.GET.get("next") is None:
            unccd_countries = self.request.user.get_unccd_countries()
            if unccd_countries:
                country_keyword = unccd_countries[0].keyword
                redirect_to = "{}?{}".format(
                    reverse("wocat:questionnaire_list"),
                    QuestionnaireConfiguration.get_country_filter(country_keyword),
                )
        # Prevent redirecting to other/invalid hosts - i.e. prevent xsrf
        if not url_has_allowed_host_and_scheme(redirect_to, [self.request.get_host()]):
            redirect_to = resolve_url(settings.LOGIN_REDIRECT_URL)
        return redirect_to


class ProfileView(LoginRequiredMixin, DetailView):
    """
    Display the users questionnaires (and in future: notifications).

    Questionnaires are loaded from the template (asynchronously).
    """

    template_name = "questionnaires.html"

    def get_object(self, queryset=None):
        return self.request.user

    def get_questionnaires(self):
        """
        Fetch questionnaires for current user.
        """
        return query_questionnaires(
            request=self.request,
            configuration_code="wocat",
            only_current=False,
            limit=None,
        )

    def get_status_list(self) -> dict:
        """
        Fetch all (distinct) statuses that at least one questionnaire of the
        current user has.
        """
        questionnaires = self.get_questionnaires()
        statuses = (
            questionnaires.order_by("status")
            .distinct("status")
            .values_list("status", flat=True)
        )
        status_choices = dict(STATUSES)  # cast to dict for easier access.
        return {status: _(status_choices[status]) for status in statuses}

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["statuses"] = self.get_status_list()
        return context


class UserDetailView(DetailView):
    """
    Show some information about the requested user:
    - information (name)
    - focal point countries
    - public questionnaires

    """

    context_object_name = "detail_user"
    model = User
    template_name = "details.html"

    def get_object(self, queryset=None):
        obj = super().get_object(queryset=queryset)
        # Update the user details
        user_info = remote_user_client.get_user_information(obj.id)
        remote_user_client.update_user(obj, user_info)
        return obj

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        unccd_countries_list = []
        unccd_countries = self.object.get_unccd_countries()
        for country in unccd_countries:
            unccd_countries_list.append(
                (
                    country,
                    "{}?{}".format(
                        reverse("wocat:questionnaire_list"),
                        QuestionnaireConfiguration.get_country_filter(country.keyword),
                    ),
                )
            )
        context["unccd_countries"] = unccd_countries_list
        return context


class QuestionnaireListMixin(ListView):
    """
    Mixin for paginated questionnaires.
    """

    template_name = "questionnaire_status_list.html"
    per_page = 3  # use qcats default paginator

    @property
    def status(self):
        raise NotImplementedError

    def get_filter_user(self):
        raise NotImplementedError

    def get_queryset(self):
        """
        Fetch all questionnaires from the current user with the requested
        status.
        """
        return query_questionnaires(
            request=self.request,
            configuration_code="wocat",
            only_current=False,
            limit=None,
            **self.get_filter_user(),
        ).filter(status=self.status)

    def get_context_data(self, **kwargs) -> dict:
        """
        Provide context data in qcats default way. Pagination happens in the
        parents get_context_data method.
        """
        context = super().get_context_data(**kwargs)
        questionnaires, paginator = get_paginator(
            objects=context["object_list"],
            page=self.request.GET.get("page", 1),
            limit=self.per_page,
        )
        context["list_values"] = get_list_values(
            questionnaire_objects=questionnaires, status_filter=Q()
        )
        context.update(
            **get_pagination_parameters(self.request, paginator, questionnaires)
        )
        return context


class PublicQuestionnaireListView(QuestionnaireListMixin):
    """
    Get public questionnaires the user defined in the url.
    """

    @property
    def status(self):
        return settings.QUESTIONNAIRE_PUBLIC

    def get_filter_user(self):
        user = get_object_or_404(User, id=self.kwargs["user_id"])
        return {"user": user}


class QuestionnaireStatusListView(LoginRequiredMixin, QuestionnaireListMixin):
    """
    Display all questionnaires for the requested status. Results are paginated.
    """

    @property
    def status(self):
        """
        Validate status from request.
        """
        try:
            status = int(self.request.GET.get("status"))
        except (TypeError, ValueError):
            raise Http404()

        if status not in dict(STATUSES).keys():
            raise Http404()

        return status

    def get_filter_user(self):
        """
        If no user is set, questionnaires are fetched according to permissions.
        This is the specified behaviour for all statuses (except 'public'), as
        questionnaires that require some kind of action should be listed.

        For published questionnaires, only the questionnaires that the user has
        worked on must be shown - so the user, not the permissions (roles) are
        important.
        """
        return {
            "user": (
                self.request.user
                if self.status is settings.QUESTIONNAIRE_PUBLIC
                else None
            )
        }  # noqa


class QuestionnaireSearchView(LoginRequiredMixin, ListView):
    """

apps/accounts/templates/details.html
{% extends 'base.html' %}

{% load i18n static %}


{% block bodyclass %}layout-wocat{% endblock %}
{% block navclass %}is-wocat{% endblock %}

{% block content %}
  <main class="row" role="main">
    <div class="small-12 columns">
      <h1 class="is-title">{% trans "User Details" %}</h1>
    </div>
    <section class="tech-list small-12 columns">
      <div class="tech-group">
        <h2 class="is-group">{% trans "Information" %}</h2>
        <div class="row">
          <div class="small-4 medium-3 large-2 columns"><p>{% trans "First name:" %}</p></div>
          <div class="small-8 medium-9 large-10 columns"><p>{{ detail_user.firstname }}</p></div>
        </div>
        <div class="row">
          <div class="small-4 medium-3 large-2 columns"><p>{% trans "Last name:" %}</p></div>
          <div class="small-8 medium-9 large-10 columns"><p>{{ detail_user.lastname }}</p></div>
        </div>
        {% if request.user.is_authenticated %}
          <div class="row">
            <div class="small-4 medium-3 large-2 columns"><p>{% trans "Email:" %}</p></div>
            <div class="small-8 medium-9 large-10 columns">
              <p>
                {{ detail_user.email }}
                {% if request.user == detail_user %}
                  (<a href="{% url 'notification_preferences' %}">{% trans "Notification preferences" %}</a>)
                {% endif %}
              </p>
            </div>
          </div>
        {% endif %}
      </div>
    </section>
    {% if unccd_countries %}
      <section class="tech-list small-12 columns">
        <div class="tech-group">
          <h2 class="is-group">{% trans "UNCCD national focal point" %}</h2>
          <div class="row">
            <div class="small-12 columns user-unccd-focal-point">
              <img src="{% static 'assets/img/unccd_logo.svg' %}" alt="{% trans "UNCCD" %}">
              <span>{% trans "UNCCD focal point for country:" %} <strong>
              {% for country in unccd_countries %}
                <a href="{{ country.1 }}" class="link">{{ country.0 }}</a>
              {% endfor %}
            </strong></span>
            </div>
          </div>
        </div>
      </section>
    {% endif %}
    <section class="tech-list small-12 columns">
      <div class="tech-group">
        <h2 class="is-group">{% trans "Public questionnaires" %}</h2>
        <div class="row">
          <div class="small-12 columns" id="public-questionnaires" data-url="{% url 'accounts:questionnaires_public_list' user_id=detail_user.id %}">
          </div>
        </div>
      </div>
    </section>
  </main>
{% endblock %}

{% block js %}
    {{ block.super }}
    <script>
        $(function () {
            const questionnairesContainer = $('#public-questionnaires');
            const url = questionnairesContainer.data('url');
            const spinner = '<img src="{% static 'assets/img/ajax-loader.gif' %}">';

            var loadQuestionnaires = function (page) {
                questionnairesContainer.html(spinner);
                $.ajax({
                    url: url + '?status=4&page=' + page
                }).done(function (data) {
                    questionnairesContainer.html(data);
                });
            };

            loadQuestionnaires(1);

            questionnairesContainer.on('click', 'ul.pagination li a', function () {
                var page = getURLParameter($(this).attr('href'), 'page');
                loadQuestionnaires(page);
                return false;
            });

            function getURLParameter(url, name) {
                return (RegExp(name + '=' + '(.+?)(&|$)').exec(url) || [, null])[1];
            }
        });
    </script>
{% endblock %}

apps/accounts/templates/login.html
{% extends 'base.html' %}

{% load i18n %}
{% load floppyforms %}

{% block content %}
  <main role="main">
    <div class="row large-no-gutters">
      <div class="large-12 columns">
        <h1 class="is-title">{% trans "Login" %}</h1>

        {% if next_url %}
          <div class="alert-box info is-rhythmed-2">{% trans "Please log in to access this page." %}</div>
        {% endif %}

        <form action="{{ login_url }}" method="post" class="user-login js-submit-once">
            {% csrf_token %}
            {% formrow form.username %}
            {% formrow form.password %}
            {% if form.non_field_errors %}
              {{ form.non_field_errors }}
            {% endif %}
            <input id="button_login" type="submit" name="submit"
                   class="button" value="{% trans "Login" %}"/>
        </form>

      </div>
    </div>

    <div class="row large-no-gutters is-rhythmed-3">

      <div class="large-12 columns">
        <h2 class="is-group">{% trans "No login?" %}</h2>
        <p>{% trans "If you do not yet have a login, please visit " %} <a
                      href="https://www.wocat.net/accounts/signup/"
                      class="link">{% trans "WOCAT" %}</a> {% trans " and register for a free account." %}
              </p>

        <h2 class="is-group">{% trans "Forgot your password?" %}</h2>
        <p>{% trans "Please visit " %} <a href="https://www.wocat.net/accounts/password/reset/"
                                         class="link">{% trans "WOCAT" %}</a> {% trans " and reset your password." %}
        </p>

      </div>
    </div>
  </main>

{% endblock %}

apps/accounts/templates/questionnaire_search.html
{% extends 'technologies/base.html' %}

{% load i18n %}

{% block bodyclass %}layout-technologies{% endblock %}

{% block content %}

  <div class="top-bar-search">
    <div class="row large-no-gutters">
      <form action="{% url "accounts:staff_questionnaires_search" %}" method="get" class="questionnaire-search-form">
        <input type="text" value="{{ request.GET.term }}" name="term" class="questionnaire-search">
        <input type="submit" class="search-submit button" value="Search">
      </form>
    </div>
  </div>

  <main class="row large-collapse" role="main">
    <section class="tech-list small-12 columns">
      <div class="tech-group">
        <h2 class="is-group">{% trans "Search results" %} (<span id="questionnaire-count">{{ count }}</span>)</h2>
        <div id="questionnaire-list">
          {% include "questionnaire/partial/list.html" %}
        </div>
      </div>
      <div id="pagination" class="is-rhythmed-2">
        {% include "pagination.html" %}
      </div>
    </section>
  </main>

{% endblock %}

apps/accounts/templates/questionnaire_status_list.html
{% include 'questionnaire/partial/list.html' %}

{% include "pagination.html" %}

apps/accounts/templates/questionnaires.html
{% extends 'base.html' %}

{% load i18n static %}

{% block bodyclass %}layout-wocat{% endblock %}
{% block navclass %}is-wocat{% endblock %}

{% block content %}
    <main class="row" role="main">
        <div class="small-12 columns">
            <h1 class="is-title">{% trans "My SLM data" %}
                <a href="{% url 'wocat:add' %}" class="button large right">{% trans "Add SLM data" %}</a>
            </h1>
        </div>
        <div class="small-12 columns">
            <section class="tech-list small-12 columns">
                <div class="tech-group">
                    <h2 class="is-group">
                        {% trans "Latest notifications" %} |
                        <a href="{% url 'notification_list' %}">{% trans "All notifications" %}</a>
                    </h2>
                    <div id="latest-notification-updates"></div>
                </div>
            </section>
        </div>
        {% if request.user.is_staff %}
            <div class="small-12 columns">
                <section class="tech-list small-12 columns">
                    <div class="tech-group">
                        <h2 class="is-group">{% trans "Search" %}</h2>
                        <form action="{% url "accounts:staff_questionnaires_search" %}" method="get"
                              class="questionnaire-search-form">
                            <input type="search" id="search-questionnaires" name="term"
                                   data-url="{% url "accounts:staff_questionnaires_search" %}"
                                   placeholder="{% trans "Search questionnaires by name, compilers name or country ISO code (alpha-3, caps: https://www.iso.org/obp/ui/#search)" %}"
                                   class="questionnaire-search">
                            <input type="submit" class="search-submit button " value="Search">
                        </form>
                    </div>
                </section>
            </div>
        {% endif %}
        <div class="small-12 columns">
            {% for status, name in statuses.items %}
                <section class="tech-list small-12 columns">
                    <div class="tech-group">
                        <h2 class="is-group">{{ name }}</h2>
                        <div class="questionnaire-list" data-status="{{ status }}">
                            <div id="status-{{ status }}" class="questionnaire-status-list"></div>
                        </div>
                    </div>
                </section>
                {% empty %}
                <section class="tech-list small-12 columns">
                    <div class="tech-group">
                        <p>{% trans "No SLM data found." %}</p>
                    </div>
                </section>
            {% endfor %}
        </div>
    </main>
{% endblock %}

{% block js %}
    {{ block.super }}
    <script src="{% static 'notifications/js/ajaxCsrf.js' %}"></script>
    <script src="{% static 'notifications/js/notificationActions.js' %}"></script>

    <script>
        $(document).ready(function () {

            var spinner = '<img src="{% static 'assets/img/ajax-loader.gif' %}">';
            var latestUpdatesContainer = $('#latest-notification-updates');
            var searchInput = $('#search-questionnaires');

            // initialize isRead plugin.
            latestUpdatesContainer.bindNotificationActions({
                csrfToken: '{{ csrf_token }}',
                readUrl: '{% url 'notification_read' %}',
                notificationsUrl: '{% url 'notification_partial_list' %}',
                todoUrl: '{% url 'notification_todo_list' %}',
                initialParams: '?is_teaser',
                isTeaser: true,
                questionnairesUrl: '{% url 'notification_questionnaire_logs' %}',
                user: '{{ request.user.id }}',
                spinner: spinner
            });

            // helper to execute the ajax call and replace the container with the response.
            var loadQuestionnaires = function (status, page) {
                $.ajax({
                    url: '{% url 'accounts:questionnaires_status_list' %}?status=' + status + '&page=' + page,
                    method: 'GET'
                }).done(function (data) {
                    $('#status-' + status).html(data);
                    // Initialize foundation elements (again), eg. tooltips
                    $(document).foundation();
                });
            };

            // load data when initializing the dom. display a spinner, as this may require loading the configuration
            // thus may take some time.
            $('[data-status]').each(function () {
                var status = $(this).data('status');
                $('#status-' + status).html(spinner);
                loadQuestionnaires(status, 1);
            });

            // load data on click on paginator
            $('.questionnaire-list').on('click', 'ul.pagination li a', function () {
                var page = getURLParameter($(this).attr('href'), 'page');
                if (page) {
                    loadQuestionnaires($(this).parents('.questionnaire-list:first').data('status'), page)
                }
                return false;
            });

            searchInput.autocomplete({
                minLength: 3,
                source: searchInput.data("url"),
                select: function (event, ui) {
                    window.location.href = ui.item.url;
                },
                open: function (event, ui) {
                    $(".ui-autocomplete").append(
                        "<li class='see-all'><a>{% trans "See all results... " %}</a></li>"
                    );
                }
            }).autocomplete("instance")._renderItem = function (ul, item) {
                return $("<li>")
                    .append(
                        "<strong>" + item.name + "</strong> (" + item.status +
                        ")<br>Compiler: " + item.compilers + " | Country: " + item.country
                    ).appendTo(ul);
            };
            // For some reason, previously "focused" li is still active when
            // hovering over the added link. Remove focus class manually.
            $("body").on("mouseover", ".see-all", function () {
                $(this).parent('ul').find('li.ui-state-focus').removeClass('ui-state-focus');
            });
            $("body").on("click", ".see-all", function () {
                searchInput.parent("form").submit();
            })
        });

        function getURLParameter(url, name) {
            return (RegExp(name + '=' + '(.+?)(&|$)').exec(url) || [, null])[1];
        }
    </script>
{% endblock %}